#ifndef PCG64_H
#define PCG64_H

// Build and use shared library:
//   gcc -std=c23 -c -fpic -o pcg64.o pcg64.c
//   gcc -shared -o libpcg64.so pcg64.o
//   gcc -lpcg64 -o main main.c
//
// Link statically:
//   gcc -std=c23 -c -o pcg64.o pcg64.c
//   gcc -o main main.c pcg64.o

// This implementation depends on native support for __int128.

// For copyright, see implementation file.

#include <stdint.h>

typedef unsigned __int128 uint128_t;
typedef struct pcg64_t { uint128_t s; uint128_t q; } pcg64_t;

pcg64_t pcg64_init_values(uint128_t state, uint128_t seq);
pcg64_t pcg64_init_getrandom();
uint64_t pcg64_random(pcg64_t *);
uint64_t pcg64_bounded(pcg64_t *, uint64_t n);

#endif
